/*
   List of integers (not a generic list).
*/
#include <stdio.h>
#include <stdlib.h> // exit()

struct Node {
   int num;
   struct Node *tail;
};


int empty(struct Node *list) {
   return NULL == list;
}


int head(struct Node *list) {
   if (NULL == list)
      exit(-1);  // C does not have exceptions

   return list->num;
}


struct Node* tail(struct Node *list) {
   if (NULL == list)
      exit(-1);  // C does not have exceptions

   return list->tail;
}


struct Node* cons(int i, struct Node *list) {
   struct Node *newNode = (struct Node*)malloc(sizeof(struct Node));
   newNode->num = i;
   newNode->tail = list;
   return newNode;
}


int length(struct Node *list) {
   int counter = 0;
   while (NULL != list) {
      counter++;
      list = list->tail; // (*list).tail;
   }
   return counter;
}


int lengthRec(struct Node *list) {
   if (NULL == list) // empty list
      return 0;
   else              // non-empty list
      return 1 + lengthRec(list->tail); // recursion
}


int lookUp(int i, struct Node *list) {
   if (NULL == list)        // empty list
      return 0;
   else if (i == list->num) // non-empty list
      return 1;
   else
      return lookUp(i, list->tail); // recursion
}


int equals(struct Node *list1, struct Node *list2) {
   if (list1 == list2) return 1;
   if (NULL == list1 || NULL == list2) return 0;
   while (NULL != list1 && NULL != list2) {
      if (list1->num != list2->num)
         return 0;
      list1 = list1->tail;
      list2 = list2->tail;
   }
   if (NULL != list1 || NULL != list2) return 0;
   return 1;
}


int equalsRec(struct Node *list1, struct Node *list2) {
   if (list1 == list2)
      return 1;
   else if (NULL == list1 || NULL == list2) // one list is empty but the other isn't
      return 0;
   else if (list1->num != list2->num)
      return 0;
   else
      return equalsRec(list1->tail, list2->tail); // recursion
}


void printList(struct Node *list) {
   printf("[");
   if (NULL != list) {
      printf("%d", list->num);
      list = list->tail;
   }
   while (NULL != list) {
      printf(", %d", list->num);
      list = list->tail;
   }
   printf("]\n");
}
