/*
   This is the "non-empty list" implementation.

   This implementation is (indirectly) recursive, since
   a List_Node<T> extends List<T> and holds a reference to a List<T>.
*/
public final class List_Node<T> extends List<T>
{
   T data;
   List<T> tail;  // recursive reference to List<T>

   public List_Node(T data) {
      this(data, new List_Nil<T>());
   }

   public List_Node(T data, List<T> tail) {
      if (null == data || null == tail) // tail is not allowed to be null
         throw new IllegalArgumentException();

      this.data = data;
      this.tail = tail;
   }


   public boolean empty() {
      return false;
   }


   public T head() {
      return data;
   }


   public List<T> tail() {
      return tail;
   }


   public List<T> cons(T data) {
      return new List_Node<T>(data, this);
   }


   public String toString() {
      String result = "[" + data;
      for (List list = this.tail; ! (list instanceof List_Nil); list = list.tail()) {
         result += ", " + list.head();
      }
      result += "]";
      return result;
   }
}
